package org.dromara.zhishu.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.dromara.zhishu.domain.ZhishuShopImages;
import org.dromara.zhishu.domain.bo.ZhishuShopImagesBo;
import org.dromara.zhishu.domain.vo.ZhishuShopImagesVo;
import org.dromara.zhishu.mapper.ZhishuShopImagesMapper;
import org.dromara.zhishu.service.IZhishuShopImagesService;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 商品图片Service业务层处理
 *
 * @author Lion Li
 * @date 2025-03-13
 */
@RequiredArgsConstructor
@Service
public class ZhishuShopImagesServiceImpl implements IZhishuShopImagesService {

    private final ZhishuShopImagesMapper baseMapper;

    /**
     * 查询商品图片
     *
     * @param id 主键
     * @return 商品图片
     */
    @Override
    public ZhishuShopImagesVo queryById(String id){
        return baseMapper.selectVoById(id);
    }

    @Override
    public List<ZhishuShopImagesVo> selectShopImagesByShopId(String goodsId) {
        return baseMapper.selectShopImagesByShopId(goodsId);
    }

    /**
     * 分页查询商品图片列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 商品图片分页列表
     */
    @Override
    public TableDataInfo<ZhishuShopImagesVo> queryPageList(ZhishuShopImagesBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ZhishuShopImages> lqw = buildQueryWrapper(bo);
        Page<ZhishuShopImagesVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的商品图片列表
     *
     * @param bo 查询条件
     * @return 商品图片列表
     */
    @Override
    public List<ZhishuShopImagesVo> queryList(ZhishuShopImagesBo bo) {
        LambdaQueryWrapper<ZhishuShopImages> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ZhishuShopImages> buildQueryWrapper(ZhishuShopImagesBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ZhishuShopImages> lqw = Wrappers.lambdaQuery();
        lqw.orderByDesc(ZhishuShopImages::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getGoodsId()), ZhishuShopImages::getGoodsId, bo.getGoodsId());
        lqw.eq(StringUtils.isNotBlank(bo.getPath()), ZhishuShopImages::getPath, bo.getPath());
        return lqw;
    }

    /**
     * 新增商品图片
     *
     * @param bo 商品图片
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ZhishuShopImagesBo bo) {
        ZhishuShopImages add = MapstructUtils.convert(bo, ZhishuShopImages.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改商品图片
     *
     * @param bo 商品图片
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ZhishuShopImagesBo bo) {
        ZhishuShopImages update = MapstructUtils.convert(bo, ZhishuShopImages.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ZhishuShopImages entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除商品图片信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<String> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }

}
